// GPViewerView.cpp : CGPViewerView NX̎
//

#include "stdafx.h"
#include "GPViewer.h"
#include <math.h>

#include "GPViewerDoc.h"
#include "GPViewerView.h"
#include "input.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

int GetEncoderClsid( TCHAR* format, CLSID* pClsid )
{
    UINT num, size;
    GetImageEncodersSize( &num, &size) ;
    ImageCodecInfo* pci = (ImageCodecInfo*)( malloc(size) );
    GetImageEncoders(num, size, pci);

    for (int i = 0; i < num; i++) {
        if( _tcscmp( pci[i].MimeType, format ) == 0 ) {
            *pClsid = pci[i].Clsid;
            free(pci);
            return 0;
        }
    }
    free(pci);

    return 1;
}

int SaveBitmapImage( HBITMAP hbmp, TCHAR* fileName )
{

    Bitmap* pbmp = Bitmap::FromHBITMAP( hbmp, NULL );
    CLSID clsid;
    GetEncoderClsid( _T("image/jpeg"), &clsid) ;

	ULONG nQuality = 100;
	EncoderParameters cEncParams;  
	cEncParams.Count=1;  
	cEncParams.Parameter[0].Guid= EncoderQuality;  
	cEncParams.Parameter[0].NumberOfValues= 1;  
	cEncParams.Parameter[0].Type = EncoderParameterValueTypeLong;  
	cEncParams.Parameter[0].Value =&nQuality;  

    pbmp->Save(fileName, &clsid, &cEncParams);
    delete pbmp;
    
    return 0;
}

// CGPViewerView

IMPLEMENT_DYNCREATE(CGPViewerView, CView)

BEGIN_MESSAGE_MAP(CGPViewerView, CView)
	ON_WM_CREATE()
	ON_WM_PAINT()
//	ON_WM_TIMER()
	ON_COMMAND(ID_FILE_SAVE_AS, &CGPViewerView::OnFileSaveAs)
	ON_COMMAND(ID_FILE_SAVE_AS2, &CGPViewerView::OnFileSaveAs2)
	ON_COMMAND(ID_ITEM_ROT90, &CGPViewerView::OnRot90)
	ON_COMMAND(ID_ITEM_ROTn90, &CGPViewerView::OnRotn90)
	ON_COMMAND(ID_ITEM_FIT, &CGPViewerView::OnFit)
	ON_COMMAND(ID_ITEM_FIT2, &CGPViewerView::OnFit2)
	ON_COMMAND(ID_ITEM_CPD, &CGPViewerView::OnCPD)
	ON_COMMAND(ID_ITEM_CP, &CGPViewerView::OnCP)
	ON_COMMAND(ID_ITEM_R0, &CGPViewerView::OnBright0)
	ON_COMMAND(ID_ITEM_R1, &CGPViewerView::OnBright1)
	ON_COMMAND(ID_ITEM_Rn1, &CGPViewerView::OnBright1n)
	ON_COMMAND(ID_ITEM_C0, &CGPViewerView::OnContrast0)
	ON_COMMAND(ID_ITEM_C1, &CGPViewerView::OnContrast1)
	ON_COMMAND(ID_ITEM_Cn1, &CGPViewerView::OnContrast1n)
END_MESSAGE_MAP()

CGPViewerView::CGPViewerView()
{
	// TODO: \zR[hɒǉ܂B
	m_pImage = NULL;
	m_Scale = 1;
	m_Index = 0;
	m_Rotate = 0;
	m_ScaleFlg = 0;
	m_ImagePxRight = 0;
	m_pImagePx = NULL;

	m_ImagePxContrast = 45;
}

CGPViewerView::~CGPViewerView()
{
	if( m_pImage ){
		delete m_pImage;
	}
	if( m_pImagePx ){
		free( m_pImagePx );
	}
}

BOOL CGPViewerView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB

	return CView::PreCreateWindow(cs);
}

// CGPViewerView `

void CGPViewerView::OnDraw(CDC* /*pDC*/)
{
	CGPViewerDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// TODO: ̏ꏊɃlCeBu f[^p̕`R[hǉ܂B
}


// CGPViewerView ff

#ifdef _DEBUG
void CGPViewerView::AssertValid() const
{
	CView::AssertValid();
}

void CGPViewerView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CGPViewerDoc* CGPViewerView::GetDocument() const // fobOȊÕo[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CGPViewerDoc)));
	return (CGPViewerDoc*)m_pDocument;
}
#endif //_DEBUG


// CGPViewerView bZ[W nh

BOOL CGPViewerView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext)
{
	// TODO: ɓȃR[hǉ邩A͊{NXĂяoĂB

	return CView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

int CGPViewerView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;

	// TODO:  ɓȍ쐬R[hǉĂB
	return 0;
}

void CGPViewerView::OnInitialUpdate()
{
	CView::OnInitialUpdate();

	// TODO: ɓȃR[hǉ邩A͊{NXĂяoĂB
	Reload();
}

void CGPViewerView::Reload( void )
{
	if( m_pImage ){
		delete m_pImage;
		m_pImage = NULL;
	}

	CGPViewerDoc *pDoc = (CGPViewerDoc*)GetDocument();
	CString path = pDoc->GetPathName() ;
	TCHAR *p = (TCHAR*)(const TCHAR*)path;
	p = p + _tcslen( p );
	for( ; *p != '\\'; p -- );
	p ++;
	pDoc->SetTitle( p );

	RECT rect;
	GetClientRect( &rect );
	m_pImage = Bitmap::FromFile( path );
	if( m_ScaleFlg != 0 )
	{
		if( rect.bottom < rect.right ){
			m_Scale = (float)rect.bottom / (float)m_pImage->GetHeight() ;;
		}
		else {
			m_Scale = (float)rect.right / (float)m_pImage->GetWidth() ;;
		}
	}
	else {
		m_Scale = 1;
	}
	m_PosX = 0;
	m_PosY = 0;
	m_Index = 0;
	m_Rotate = 0;

	TCHAR t[1024] = { 0 };
	_stprintf( t, _T("%s @Scale %1.1f%%"), pDoc->GetTitle(), m_Scale*100 );
	pDoc->SetTitle( t );

	Malloc();

	this->InvalidateRect( FALSE );
}

void CGPViewerView::Malloc( void )
{
	if( m_pImagePx ){
		free( m_pImagePx );
		m_pImagePx = NULL;
		m_ImagePxRight = 0;
		m_ImagePxContrast = 45;
	}

	BitmapData	lock;
	m_pImage->LockBits( &Rect(0,0,m_pImage->GetWidth(),m_pImage->GetHeight()), ImageLockModeRead | ImageLockModeWrite,PixelFormat24bppRGB, &lock );
	unsigned int alloc_size = lock.Stride * m_pImage->GetHeight();
	m_ImagePxSize = (lock.Stride * m_pImage->GetHeight()) / sizeof(RGBTRIPLE);
	m_pImagePx = (unsigned char*)malloc( alloc_size );
	memcpy( m_pImagePx, lock.Scan0, alloc_size );
	m_pImage->UnlockBits( &lock );
}

void CGPViewerView::Contrast( int val )
{
	//if( val < 0 )
	{
		if( val == 0 ){
			m_ImagePxContrast = 45;
		}
		if( val > 0 ){
			m_ImagePxContrast += val;
			if( m_ImagePxContrast >= 90 ){
				m_ImagePxContrast = 89;
			}
		}
		if( val < 0 ){
			m_ImagePxContrast += val;
			if( m_ImagePxContrast <= 0 ){
				m_ImagePxContrast = 1;
			}
		}
	}
}

void CGPViewerView::Bright( int val )
{
	if( val < 255 )
	{
		if( val == 0 ){
			m_ImagePxRight = 0;
		}
		if( val > 0 ){
			m_ImagePxRight += val;
			if( m_ImagePxRight > 255 ){
				m_ImagePxRight = 255;
			}
		}
		if( val < 0 ){
			m_ImagePxRight += val;
			if( m_ImagePxRight < -255 ){
				m_ImagePxRight = -255;
			}
		}
	}
}

void CGPViewerView::Mix( void )
{
	BitmapData	lock;
	m_pImage->LockBits( &Rect(0,0,m_pImage->GetWidth(),m_pImage->GetHeight()), ImageLockModeRead | ImageLockModeWrite,PixelFormat24bppRGB, &lock );
	m_ImagePxSize = (lock.Stride * m_pImage->GetHeight()) / sizeof(RGBTRIPLE);
	unsigned char *p_dst = (unsigned char*)lock.Scan0;
	unsigned char *p_src = (unsigned char*)m_pImagePx;

	unsigned char c_table[256] = { 0 };
	for( int i = 0; i < 256; i ++ ){
		double val = tan(m_ImagePxContrast * (3.1415926535 / 180)) * (i - 127) + 127;
		if( val > 255 ) {
			c_table[i] = 255;
        }
		else if (val < 0) {
			c_table[i] = 0;
		}
		else {
			c_table[i] = (unsigned char)val;
		}
	}

	for( int i = 0; i < m_ImagePxSize; i ++ )
	{
		for( int j = 0; j < 3; j ++ )
		{
			int tmp = *p_src;

			// 邳
			{
				tmp += m_ImagePxRight;
				if( tmp < 0 ){
					tmp = 0;
				}
				if( tmp > 255 ){
					tmp = 255;
				}
			}

			// RgXg
			{
				tmp = c_table[tmp];
			}

			*p_dst =(unsigned char)tmp;
			p_src ++;
			p_dst ++;
		}
	}

	m_pImage->UnlockBits( &lock );
	this->Invalidate( FALSE );
}

void CGPViewerView::OnBright0( )
{
	Bright( 0 );
	Mix();
}
void CGPViewerView::OnBright1(  )
{
	Bright( 10 );
	Mix();
}
void CGPViewerView::OnBright1n( )
{
	Bright( -10 );
	Mix();
}

void CGPViewerView::OnContrast0( )
{
	Contrast( 0 );
	Mix();
}
void CGPViewerView::OnContrast1(  )
{
	Contrast( 5 );
	Mix();
}
void CGPViewerView::OnContrast1n( )
{
	Contrast( -5 );
	Mix();
}
void CGPViewerView::UpdateInput( void )
{
	
	int update = 0;
	if( input_mx() < 0 || input_my() < 0 ){
		//return ;
	}
	CRect r;
	GetClientRect( r );

	if( input_pad() & KEY_LBUTTON && input_padt() & KEY_RBUTTON ) {
		
		if( input_mx() >= 0 && input_mx() < r.Width() &&
			input_my() >= 0 && input_my() < r.Height() ){
			m_Scale -= 0.1f;
			update = 1;

			CGPViewerDoc *pDoc = GetDocument();
			CString title = pDoc->GetTitle();
			if( _tcsstr( title, _T("@Scale") ) == 0 ){
				TCHAR t[1024] = { 0 };
				_stprintf( t, _T("%s @Scale %1.1f%%"), title, m_Scale*100 );
				pDoc->SetTitle( t );
			}
			else {
				TCHAR t[1024] = { 0 };
				TCHAR tmp[32] = { 0 };
				_tcscpy( t, title );
				*_tcsstr( t, _T("@Scale") ) = '\0';
				_stprintf( tmp, _T("@Scale %1.1f%%"), m_Scale*100 );
				_tcscat( t, tmp );
				pDoc->SetTitle( t );
			}
		}
	}
	else if( input_pad() & KEY_RBUTTON )
	{
		if( input_mdx() ){
			m_PosX += input_mdx();
			update = 1;
			
		}
		if( input_mdy() ){
			m_PosY += input_mdy();
			update = 1;
		}
	}
	else if( input_padt() & KEY_LBUTTON ){
		if( input_mx() >= 0 && input_mx() < r.Width() &&
			input_my() >= 0 && input_my() < r.Height() ){
			m_Scale += 0.1f;
			update = 1;
			TCHAR msg[512];
			_stprintf( msg, _T("%d,%d"), input_mx(), input_my() );

			CGPViewerDoc *pDoc = GetDocument();
			CString title = pDoc->GetTitle();
			if( _tcsstr( title, _T("@Scale") ) == 0 ){
				TCHAR t[1024] = { 0 };
				_stprintf( t, _T("%s @Scale %1.1f%%"), title, m_Scale*100 );
				pDoc->SetTitle( t );
			}
			else {
				TCHAR t[1024] = { 0 };
				TCHAR tmp[32] = { 0 };
				_tcscpy( t, title );
				*_tcsstr( t, _T("@Scale") ) = '\0';
				_stprintf( tmp, _T("@Scale %1.1f%%"), m_Scale*100 );
				_tcscat( t, tmp );
				pDoc->SetTitle( t );
			}
		}
	}

	int x = m_pImage->GetWidth()*m_Scale;
	int y = m_pImage->GetHeight()*m_Scale;
	if( m_PosX < -x ){
		m_PosX = -x;
		update = 1;
	}
	if( m_PosX > 0 ){
		m_PosX = 0;
		update = 1;
	}
	if( m_PosY < -y ){
		m_PosY = -y;
		update = 1;
	}
	if( m_PosY > 0 ){
		m_PosY = 0;
		update = 1;
	}

	if( update ){
		this->Invalidate( FALSE );
	}
}

void CGPViewerView::Render( CDC &cdc )
{
	Rect rs, rd;
	rs.X = 0;
	rs.Y = 0;
	rs.Width = m_pImage->GetWidth();
	rs.Height = m_pImage->GetHeight();
	
	rd = rs;
	rd.Width *= m_Scale;
	rd.Height *= m_Scale;

	rd.X = m_PosX;
	rd.Y = m_PosY;

	Graphics g( cdc.m_hDC );
	g.DrawImage( m_pImage, rd, 0, 0, m_pImage->GetWidth(), m_pImage->GetHeight(), UnitPixel );

}
void CGPViewerView::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	// TODO: ɃbZ[W nh R[hǉ܂B
	// `惁bZ[W CView::OnPaint() ĂяoȂłB

	RECT rect;
	GetClientRect( &rect );
	
	CRect rc;
    GetClientRect(&rc);
    CDC dcMem;
    dcMem.CreateCompatibleDC(&dc);
    CBitmap bmp;
    bmp.CreateCompatibleBitmap(&dc, rc.Width(), rc.Height());
    CBitmap* pOldBmp = dcMem.SelectObject(&bmp);
	dcMem.FillSolidRect(&rc, RGB(0,0,0));

	if( m_pImage ){
		Render( dcMem );
	}

	dc.BitBlt(0, 0, rc.Width(), rc.Height(), &dcMem, 0, 0, SRCCOPY);
    dcMem.SelectObject(pOldBmp);
}

void CGPViewerView::OnRot90()
{
	m_Rotate += 90;
	m_pImage->RotateFlip( Rotate90FlipNone );
	if( m_Rotate > 360 ){
		m_Rotate -= 360;
	}

	Malloc();
	Bright( 255 );
	Mix();
	this->Invalidate( FALSE );
}

void CGPViewerView::OnRotn90()
{
	m_Rotate -= 90;
	if( m_Rotate < 0 ){
		m_Rotate += 360;
	}
	m_pImage->RotateFlip( Rotate270FlipNone );

	Malloc();
	Bright( 255 );
	Mix();
	this->Invalidate( FALSE );
}

void CGPViewerView::OnFit()
{
	m_ScaleFlg = 0;
	m_Scale = 1;
	this->Invalidate( FALSE );
}

void CGPViewerView::OnFit2()
{
	RECT rect;
	GetClientRect( &rect );
	m_ScaleFlg = 1;
	if( rect.bottom < rect.right ){
		m_Scale = (float)rect.bottom / (float)m_pImage->GetHeight() ;;
	}
	else {
		m_Scale = (float)rect.right / (float)m_pImage->GetWidth() ;;
	}
	this->Invalidate( FALSE );
}

void CGPViewerView::OnCPD()
{
	TCHAR copy_dir[512] = { 0 };
	{
		TCHAR inifile[512];
		GetFullpath( inifile, _T("GPViewer.INI") );
		GetPrivateProfileString( _T("Config"), _T("COPY_DIR"), _T(""), copy_dir, sizeof(copy_dir), inifile);
	}
	EnumDirectory( AfxGetMainWnd()->m_hWnd, copy_dir );
	{
		TCHAR inifile[512];
		GetFullpath( inifile, _T("GPViewer.INI") );
		WritePrivateProfileString( _T("Config"), _T("COPY_DIR"),  copy_dir, inifile);
	}
}

void CGPViewerView::OnCP()
{
	TCHAR default_dir[512];
	TCHAR copy_dir[512] = { 0 };
	GetFullpath( default_dir, _T("") );
	{
		TCHAR inifile[512];
		GetFullpath( inifile, _T("GPViewer.INI") );
		GetPrivateProfileString( _T("Config"), _T("COPY_DIR"), default_dir, copy_dir, sizeof(copy_dir), inifile);
	}
	CGPViewerDoc *pDoc = GetDocument();
	TCHAR fn[512] = { 0 };
	_tcscpy( fn, pDoc->GetPathName() );
	TCHAR *p = fn + _tcslen( fn );
	for( ; *p != '\\'; p -- ){
	}
	p ++;

	TCHAR dst[512] = { 0 };
	_stprintf( dst, _T("%s\\%s"), copy_dir, p );
	if( CopyFile( pDoc->GetPathName(), dst, TRUE ) == FALSE )
	{
		for( int i = 0; ; i ++ ){
			_stprintf( dst, _T("%s\\%s.%05d.jpg"), copy_dir, p, i );
			if( CopyFile( pDoc->GetPathName(), dst, TRUE ) == TRUE ){
				break;
			}
		}
	}
}

void CGPViewerView::OnFileSaveAs()
{
	// TODO: ɃR}h nh R[hǉ܂B
	TCHAR fn[512];
	CString title = GetDocument()->GetTitle();
	TCHAR t[512];
	_tcscpy( t, title );
	if( _tcsstr( t, _T(" @Scale") ) == 0 ){
	}
	else {
		*_tcsstr( t, _T(" @Scale") ) = '\0';
		
	}
	_stprintf( fn, _T("%s.%05d.jpg"), t, m_Index );

	CFileDialog dlg(
		FALSE,
		_T("jpg"),
		fn,	
		OFN_OVERWRITEPROMPT,
		_T("JPEG File(*.jpg)|*.jpg|")
	);
	if( dlg.DoModal() == IDOK )
	{
		CDC *p_dc = GetDC();
		CRect rc;
		GetClientRect(&rc);
		CDC dcMem;
		dcMem.CreateCompatibleDC( p_dc );
		CBitmap bmp;
		bmp.CreateCompatibleBitmap( p_dc, rc.Width(), rc.Height());
		CBitmap* pOldBmp = dcMem.SelectObject(&bmp);
		dcMem.FillSolidRect(&rc, RGB(0,0,0));

		Render( dcMem );
		SaveBitmapImage( bmp, (TCHAR*)(const TCHAR*)dlg.GetPathName() );

		dcMem.SelectObject(pOldBmp);

		m_Index ++;
	}
}


void CGPViewerView::OnFileSaveAs2()
{
	// TODO: ɃR}h nh R[hǉ܂B
	TCHAR fn[512];
	CString title = GetDocument()->GetTitle();
	TCHAR t[512];
	_tcscpy( t, title );
	if( _tcsstr( t, _T(" @Scale") ) == 0 ){
	}
	else {
		*_tcsstr( t, _T(" @Scale") ) = '\0';
		
	}
	_stprintf( fn, _T("%s.%05d.jpg"), t, m_Index );

	CFileDialog dlg(
		FALSE,
		_T("jpg"),
		fn,
		OFN_OVERWRITEPROMPT,
		_T("JPEG File(*.jpg)|*.jpg|")
	);
	if( dlg.DoModal() == IDOK )
	{
		int w = m_pImage->GetWidth();
		int h = m_pImage->GetHeight();
		float scale_tmp = m_Scale;
		m_Scale = 1;
		CDC *p_dc = GetDC();
		CDC dcMem;
		dcMem.CreateCompatibleDC( p_dc );
		CBitmap bmp;
		bmp.CreateCompatibleBitmap( p_dc, w, h);
		CBitmap* pOldBmp = dcMem.SelectObject(&bmp);

		RECT rc;
		rc.left = 0;
		rc.right = w;
		rc.top = 0;
		rc.bottom = h;
		dcMem.FillSolidRect(&rc, RGB(0,0,0));

		Render( dcMem );
		SaveBitmapImage( bmp, (TCHAR*)(const TCHAR*)dlg.GetPathName() );

		dcMem.SelectObject(pOldBmp);

		m_Scale = scale_tmp;
		m_Index ++;
	}
}