// ListImageCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "GPViewer.h"
#include "ListImageCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define THUMWIDTH 32
#define THUMHEIGHT 32


void DoEvents(void);
/////////////////////////////////////////////////////////////////////////////
// CListImageCtrl

CListImageCtrl::CListImageCtrl()
{
}

CListImageCtrl::~CListImageCtrl()
{
}


BEGIN_MESSAGE_MAP(CListImageCtrl, CListCtrl)
	//{{AFX_MSG_MAP(CListImageCtrl)
	//}}AFX_MSG_MAP
	ON_NOTIFY(NM_DBLCLK, LIST_THUMB, &CListImageCtrl::OnNMDblclkThumb)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CListImageCtrl message handlers
// This funtion is used to load the Window dropped files into the listview


void CListImageCtrl::CreateColumn()
{
	InsertColumn(0,_T("Filename"),LVCFMT_LEFT,125,-1);
	InsertColumn(1,_T("Path"),LVCFMT_LEFT,125,-1);

	HIMAGELIST hScreens = ImageList_Create(THUMWIDTH, THUMHEIGHT, ILC_COLOR32, 0, 1);
	m_imageList.Attach(hScreens);

	SetImageList(&m_imageList, LVSIL_NORMAL);
	SetImageList(&m_imageList, LVSIL_SMALL);
}

void CListImageCtrl::RegistPicture( CString mFile )
{
	CString nFileText;
	CString nPath;
	CString pItemText=mFile;
	CFile Cf;
	DWORD TmpVal;
	TCHAR szText[MAX_PATH];

	int i=pItemText.ReverseFind('\\');

	nFileText=pItemText.Mid(i+1);
	nPath=pItemText.Left(i+1);
	i=nFileText.Find(_T("%"));

	int m_TotCount;
	HBITMAP bitm=LoadPicture(mFile);
	if (bitm!=NULL)
	{
		//List item index
		m_TotCount=GetItemCount();
		//Adding Bitmap to the Imagelist
		CBitmap*    pImage = NULL;	
		pImage = new CBitmap();		 
		pImage->Attach(bitm);
		int imgP=m_imageList.Add(pImage,RGB(0,0,0));
		delete pImage;
		DeleteObject( bitm );
		//Link to the added listview item 
		InsertItem(m_TotCount,nFileText,imgP);

		SetItemText(m_TotCount, 1, nPath);
		//Get File size
		DoEvents();
	}

	int result=GetItemCount();
	SetItemState(result, LVIS_SELECTED | 
    LVIS_FOCUSED | LVIS_ACTIVATING, LVIS_SELECTED | LVIS_FOCUSED | LVIS_ACTIVATING); 
	result--;
	EnsureVisible(result, TRUE);
	SetFocus();
	SetRedraw(TRUE);
	RedrawWindow(NULL,NULL);
}

HBITMAP CListImageCtrl::LoadPicture(CString mFile)
{
	CString pFSize;
    TCHAR wpath[MAX_PATH];
	_tcscpy( wpath, mFile );
	
    IPicture* pPic;
    OleLoadPicturePath(wpath, NULL, NULL, NULL, IID_IPicture,(LPVOID*)&pPic);
	
	if (pPic==NULL) return NULL;
    HBITMAP hPic = NULL;
    pPic->get_Handle((UINT*)&hPic);

	long nWidth=THUMWIDTH;
	long nHeight=THUMHEIGHT;

	long mWid,mHei;
	pPic->get_Height(&mHei);
	pPic->get_Width(&mWid);

	HBITMAP hPicRet = (HBITMAP)CopyImage(hPic, IMAGE_BITMAP, nWidth, nHeight , LR_COPYDELETEORG);	

	// Create Brushes for Border and BackGround
	HBRUSH hBrushBorder=::CreateSolidBrush(RGB(192, 192, 192));
	HBRUSH hBrushBk=::CreateSolidBrush(RGB(255, 255, 255));

	// Border Size
	RECT rcBorder;
	rcBorder.left=rcBorder.top=0;
	rcBorder.right=THUMWIDTH;
	rcBorder.bottom=THUMHEIGHT;

	const float fRatio=(float)THUMHEIGHT/THUMWIDTH;

	int XDest, YDest, nDestWidth, nDestHeight;
	// Calculate Rect to fit to canvas
	const float fImgRatio=(float)mHei/mWid;
	if(fImgRatio > fRatio)
	{
		nDestWidth=(THUMHEIGHT/fImgRatio);
		XDest=(THUMWIDTH-nDestWidth)/2;
		YDest=0;
		nDestHeight=THUMHEIGHT;
	}
	else
	{
		XDest=0;
		nDestWidth=THUMWIDTH;
		nDestHeight=(THUMWIDTH*fImgRatio);
		YDest=(THUMHEIGHT-nDestHeight)/2;
	}

	CClientDC cdc(this);
	HDC hDC=::CreateCompatibleDC(cdc.m_hDC);
	HBITMAP bm = CreateCompatibleBitmap(cdc.m_hDC, THUMWIDTH, THUMHEIGHT);
	HBITMAP pOldBitmapImage = (HBITMAP)SelectObject(hDC,bm);
	// Draw Background
	::FillRect(hDC, &rcBorder, hBrushBk);

	// Draw Border
	::FrameRect(hDC, &rcBorder, hBrushBorder);

	HBITMAP hBmReturn= (HBITMAP)::SelectObject(hDC, pOldBitmapImage);

	CDC hdcSrc, hdcDst;

   hdcSrc.CreateCompatibleDC(NULL);
   hdcDst.CreateCompatibleDC(NULL);

   // Load the bitmaps into memory DC
   CBitmap* hbmSrcT = (CBitmap*) hdcSrc.SelectObject(hPicRet);
   CBitmap* hbmDstT = (CBitmap*) hdcDst.SelectObject(hBmReturn);

   // This call sets up the mask bitmap.
   hdcDst.BitBlt(XDest,YDest,nDestWidth, nDestHeight, &hdcSrc,0,0,SRCCOPY);	
   //hdcDst.StretchBlt(XDest,YDest,nDestWidth, nDestHeight, &hdcSrc,0,0,48,48,SRCCOPY);

	pOldBitmapImage = (HBITMAP)SelectObject(hdcDst.m_hDC,bm);

	// Release used DC and Object
	DeleteDC(hDC);
	DeleteObject(hBrushBorder);
	DeleteObject(hBrushBk);

    return pOldBitmapImage;

}
// this function is used to enable the system messages
// this is mainly used to display the multiple images dropped on the list control

void DoEvents(void)
{
    MSG Symsg;
    
    while(PeekMessage(&Symsg,NULL,0,0,PM_REMOVE))
    {
    TranslateMessage(&Symsg);
    DispatchMessage(&Symsg);
    }
}

void CListImageCtrl::OnNMDblclkThumb(NMHDR *pNMHDR, LRESULT *pResult)
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B

	int index = GetNextItem( -1, LVNI_ALL | LVNI_SELECTED );
	if( index >= 0 )
	{
		CGPViewerApp *app = (CGPViewerApp*)AfxGetApp();
		app->OnItemGoto( index );
	}
	*pResult = 0;
}
